#!/usr/local/bin/perl
#
# This script was generated by phonegen (Tue Oct  5 10:35:34 PDT 1999)
#

#important subroutines
sub enter {
    local($word)=shift(@_);
    local($tag)=shift(@_);
    local($new)="$word:$tag";

    unless (defined($defn{$new})) {
	$defn{$new}=1;
	push(@pron,$new);
    }
}

sub getword {
    local($counter)=shift(@_);
    ($gw1,$gw2)=split(/:/,$pron[$counter]);
    ($gw1,$gw2);
}

sub change {
    local($word)=shift(@_);
    local($tag)=shift(@_);
    local($counter)=shift(@_);
    $pron[$counter]="$word:$tag";
}

sub clear {
    foreach $key (keys(%defn)) {
	delete $defn{$key};
	}
}

require("/u/drspeech/share/lib/icsiargs.pl");
$oldword="";
while(<>) {
	%defn=();
	s/^\#.*$//g;
	s/\s\#.*$//g;
	$canontag="";
	$ctag="";
	chop;
	@parts=split;
	$word=shift(@parts);
	$canon=join(" ",@parts);
	$canon=" $canon ";
	next if ($canon =~ /^\s*$/);
$lexicon="CMU" if !defined($lexicon);

##definitions
# VOWEL=AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR
# SVOWEL=AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW
# UVOWEL=AX|IX|AXR
# UNORVOWEL=AX|IX
# NASAL=M|N|NG
# LIQUID=L|R
# SEMIVOWEL=W|Y
# SYLABIC=EL|EM|EN
# VOICED=AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR|EL|EM|EN|M|N|NG|L|R|W|Y|B|D|G|DH|JH|V|Z|DX|NX
# VOICEDNONG=AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR|EL|EM|EN|N|M|L|R|W|Y|B|D|G|DH|JH|V|Z|DX|NX

##stop closures

##stop + stop

# SS1:S: B ([DGPTK]) -> [BCL] [$1]
	$canon =~ s/ B ([DGPTK]) / [BCL] [$1] /g;

# SS2:S: D ([BGPTK]) -> [DCL] [$1]
	$canon =~ s/ D ([BGPTK]) / [DCL] [$1] /g;

# SS3:S: G ([BDPTK]) -> [GCL] [$1]
	$canon =~ s/ G ([BDPTK]) / [GCL] [$1] /g;

# SS4:S: P ([BDGTK]) -> [PCL] [$1]
	$canon =~ s/ P ([BDGTK]) / [PCL] [$1] /g;

# SS5:S: T ([BDGPK]) -> [TCL] [$1]
	$canon =~ s/ T ([BDGPK]) / [TCL] [$1] /g;

# SS6:S: K ([BDGPT]) -> [KCL] [$1]
	$canon =~ s/ K ([BDGPT]) / [KCL] [$1] /g;

##stop + cons

# SC1:S: B ([SNMF]) -> [BCL] $1
	$canon =~ s/ B ([SNMF]) / [BCL] $1 /g;

# SC2:S: D ([SNMF]) -> [DCL] $1
	$canon =~ s/ D ([SNMF]) / [DCL] $1 /g;

# SC3:S: G ([SNMF]) -> [GCL] $1
	$canon =~ s/ G ([SNMF]) / [GCL] $1 /g;

# SC4:S: P ([NMF]) -> [PCL] $1
	$canon =~ s/ P ([NMF]) / [PCL] $1 /g;

# SC5:S: T ([SNLMF]) -> [TCL] $1
	$canon =~ s/ T ([SNLMF]) / [TCL] $1 /g;

# SC6:S: K ([NMF]) -> [KCL] $1
	$canon =~ s/ K ([NMF]) / [KCL] $1 /g;

## stop + end

# SE1:S: B *$-> [BCL] 
	$canon =~ s/ B *$/ [BCL] /g;

# SE2:S: D *$-> [DCL] 
	$canon =~ s/ D *$/ [DCL] /g;

# SE3:S: G *$-> [GCL] 
	$canon =~ s/ G *$/ [GCL] /g;

# SE4:S: P *$-> [PCL] 
	$canon =~ s/ P *$/ [PCL] /g;

# SE5:S: T *$-> [TCL] 
	$canon =~ s/ T *$/ [TCL] /g;

# SE6:S: K *$-> [KCL] 
	$canon =~ s/ K *$/ [KCL] /g;

##stop-gen

# SG1:S: B -> [BCL] [B]
	$canon =~ s/ B / [BCL] [B] /g;

# SG2:S: D -> [DCL] [D]
	$canon =~ s/ D / [DCL] [D] /g;

# SG3:S: G -> [GCL] [G]
	$canon =~ s/ G / [GCL] [G] /g;

# SG4:S: P -> [PCL] [P]
	$canon =~ s/ P / [PCL] [P] /g;

# SG5:S: K -> [KCL] [K]
	$canon =~ s/ K / [KCL] [K] /g;

# SG6:S: T -> [TCL] [T]
	$canon =~ s/ T / [TCL] [T] /g;

## get rid of brackets

# BR1:SD: \[ -> 
	$canon =~ s/\[//g;

# BR2:SD: \] ->
	$canon =~ s/\]//g;

	@pron=();
	if ($canontag ne "") {
	$ctag="(+$lexicon$canontag)"; }
	 else { 
	$ctag="+$lexicon"; }
	&enter($canon,$ctag);

	for($counter=0;$counter<=$#pron;$counter++) {
		($tmp,$tag)=&getword($counter);

##reduced vowels

# RV1:ON: (AA|AE|AH|AO|EH|ER|EY|OW|UH)0 -> AX
	$oldtmp = $tmp;
	$oldtag = $tag;
	$tmp =~ s/( (AA|AE|AH|AO|EH|ER|EY|OW|UH)0 )/<$1>/g;
	while ($tmp =~ /</) {
	    &change($oldtmp,$oldtag." -RV1",$counter);
	    $newtmp=$tmp;
	    if ($newtmp =~ s/< (AA|AE|AH|AO|EH|ER|EY|OW|UH)0 >/ AX /) {
	      $tmp =~ s/<//;
	      $tmp =~ s/>//;
	      $newtmp =~ s/[<>]//g;
	      &enter($newtmp,$oldtag." +RV1");
	      $oldtag .= " -RV1";
	    }
	  }
	($tmp,$tag)=&getword($counter);


# RV2:ON: (IY|IH|UW)0 -> IX
	$oldtmp = $tmp;
	$oldtag = $tag;
	$tmp =~ s/( (IY|IH|UW)0 )/<$1>/g;
	while ($tmp =~ /</) {
	    &change($oldtmp,$oldtag." -RV2",$counter);
	    $newtmp=$tmp;
	    if ($newtmp =~ s/< (IY|IH|UW)0 >/ IX /) {
	      $tmp =~ s/<//;
	      $tmp =~ s/>//;
	      $newtmp =~ s/[<>]//g;
	      &enter($newtmp,$oldtag." +RV2");
	      $oldtag .= " -RV2";
	    }
	  }
	($tmp,$tag)=&getword($counter);


# RV3:ON: ER0 -> AXR
	$oldtmp = $tmp;
	$oldtag = $tag;
	$tmp =~ s/( ER0 )/<$1>/g;
	while ($tmp =~ /</) {
	    &change($oldtmp,$oldtag." -RV3",$counter);
	    $newtmp=$tmp;
	    if ($newtmp =~ s/< ER0 >/ AXR /) {
	      $tmp =~ s/<//;
	      $tmp =~ s/>//;
	      $newtmp =~ s/[<>]//g;
	      &enter($newtmp,$oldtag." +RV3");
	      $oldtag .= " -RV3";
	    }
	  }
	($tmp,$tag)=&getword($counter);


# :D: [012] ->
	$tmp =~ s/[012]//g;
	&change($tmp,$tag,$counter);
	($tmp,$tag)=&getword($counter);


##glottal rules

##sylabic rules

# SL1:ON: (UNORVOWEL) N -> EN
	$oldtmp = $tmp;
	$oldtag = $tag;
	$tmp =~ s/( (AX|IX) N )/<$1>/g;
	while ($tmp =~ /</) {
	    &change($oldtmp,$oldtag." -SL1",$counter);
	    $newtmp=$tmp;
	    if ($newtmp =~ s/< (AX|IX) N >/ EN /) {
	      $tmp =~ s/<//;
	      $tmp =~ s/>//;
	      $newtmp =~ s/[<>]//g;
	      &enter($newtmp,$oldtag." +SL1");
	      $oldtag .= " -SL1";
	    }
	  }
	($tmp,$tag)=&getword($counter);


# SL2:ON: (UNORVOWEL) M -> EM
	$oldtmp = $tmp;
	$oldtag = $tag;
	$tmp =~ s/( (AX|IX) M )/<$1>/g;
	while ($tmp =~ /</) {
	    &change($oldtmp,$oldtag." -SL2",$counter);
	    $newtmp=$tmp;
	    if ($newtmp =~ s/< (AX|IX) M >/ EM /) {
	      $tmp =~ s/<//;
	      $tmp =~ s/>//;
	      $newtmp =~ s/[<>]//g;
	      &enter($newtmp,$oldtag." +SL2");
	      $oldtag .= " -SL2";
	    }
	  }
	($tmp,$tag)=&getword($counter);


# SL3:ON: (UNORVOWEL) L -> EL
	$oldtmp = $tmp;
	$oldtag = $tag;
	$tmp =~ s/( (AX|IX) L )/<$1>/g;
	while ($tmp =~ /</) {
	    &change($oldtmp,$oldtag." -SL3",$counter);
	    $newtmp=$tmp;
	    if ($newtmp =~ s/< (AX|IX) L >/ EL /) {
	      $tmp =~ s/<//;
	      $tmp =~ s/>//;
	      $newtmp =~ s/[<>]//g;
	      &enter($newtmp,$oldtag." +SL3");
	      $oldtag .= " -SL3";
	    }
	  }
	($tmp,$tag)=&getword($counter);


# SL4:ON: (UNORVOWEL) R -> AXR
	$oldtmp = $tmp;
	$oldtag = $tag;
	$tmp =~ s/( (AX|IX) R )/<$1>/g;
	while ($tmp =~ /</) {
	    &change($oldtmp,$oldtag." -SL4",$counter);
	    $newtmp=$tmp;
	    if ($newtmp =~ s/< (AX|IX) R >/ AXR /) {
	      $tmp =~ s/<//;
	      $tmp =~ s/>//;
	      $newtmp =~ s/[<>]//g;
	      &enter($newtmp,$oldtag." +SL4");
	      $oldtag .= " -SL4";
	    }
	  }
	($tmp,$tag)=&getword($counter);


##flaps

# FL1:ON: (VOWEL) [TD]CL [TD] (UVOWEL) -> $1 DX $2
	$oldtmp = $tmp;
	$oldtag = $tag;
	$tmp =~ s/( (AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR) [TD]CL [TD] (AX|IX|AXR) )/<$1>/g;
	while ($tmp =~ /</) {
	    &change($oldtmp,$oldtag." -FL1",$counter);
	    $newtmp=$tmp;
	    if ($newtmp =~ s/< (AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR) [TD]CL [TD] (AX|IX|AXR) >/ $1 DX $2 /) {
	      $tmp =~ s/<//;
	      $tmp =~ s/>//;
	      $newtmp =~ s/[<>]//g;
	      &enter($newtmp,$oldtag." +FL1");
	      $oldtag .= " -FL1";
	    }
	  }
	($tmp,$tag)=&getword($counter);


# FL2:ON: (VOWEL) R [TD]CL [TD] (UVOWEL) -> $1 R DX $2
	$oldtmp = $tmp;
	$oldtag = $tag;
	$tmp =~ s/( (AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR) R [TD]CL [TD] (AX|IX|AXR) )/<$1>/g;
	while ($tmp =~ /</) {
	    &change($oldtmp,$oldtag." -FL2",$counter);
	    $newtmp=$tmp;
	    if ($newtmp =~ s/< (AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR) R [TD]CL [TD] (AX|IX|AXR) >/ $1 R DX $2 /) {
	      $tmp =~ s/<//;
	      $tmp =~ s/>//;
	      $newtmp =~ s/[<>]//g;
	      &enter($newtmp,$oldtag." +FL2");
	      $oldtag .= " -FL2";
	    }
	  }
	($tmp,$tag)=&getword($counter);


##voiced h

# VH1:ON: (VOICED) HH (VOICED) -> $1 HV $2
	$oldtmp = $tmp;
	$oldtag = $tag;
	$tmp =~ s/( (AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR|EL|EM|EN|M|N|NG|L|R|W|Y|B|D|G|DH|JH|V|Z|DX|NX) HH (AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR|EL|EM|EN|M|N|NG|L|R|W|Y|B|D|G|DH|JH|V|Z|DX|NX) )/<$1>/g;
	while ($tmp =~ /</) {
	    &change($oldtmp,$oldtag." -VH1",$counter);
	    $newtmp=$tmp;
	    if ($newtmp =~ s/< (AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR|EL|EM|EN|M|N|NG|L|R|W|Y|B|D|G|DH|JH|V|Z|DX|NX) HH (AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR|EL|EM|EN|M|N|NG|L|R|W|Y|B|D|G|DH|JH|V|Z|DX|NX) >/ $1 HV $2 /) {
	      $tmp =~ s/<//;
	      $tmp =~ s/>//;
	      $newtmp =~ s/[<>]//g;
	      &enter($newtmp,$oldtag." +VH1");
	      $oldtag .= " -VH1";
	    }
	  }
	($tmp,$tag)=&getword($counter);

		$tmp =~ s/^ *//;
		$tmp =~ s/  */ /g;
		$tmp =~ s/ *$//;

		$tmp =~ tr/A-Z/a-z/;
		$word =~ tr/A-Z/a-z/;
		print $word,":",$tmp,":",$tag,"\n";
	}
}
