#!/usr/local/bin/perl
#
# This script was generated by phonegen (Tue Oct  5 10:50:24 PDT 1999)
#

#important subroutines
sub enter {
    local($word)=shift(@_);
    local($tag)=shift(@_);
    local($new)="$word:$tag";

    unless (defined($defn{$new})) {
	$defn{$new}=1;
	push(@pron,$new);
    }
}

sub getword {
    local($counter)=shift(@_);
    ($gw1,$gw2)=split(/:/,$pron[$counter]);
    ($gw1,$gw2);
}

sub change {
    local($word)=shift(@_);
    local($tag)=shift(@_);
    local($counter)=shift(@_);
    $pron[$counter]="$word:$tag";
}

sub clear {
    foreach $key (keys(%defn)) {
	delete $defn{$key};
	}
}

require("/u/drspeech/share/lib/icsiargs.pl");
$oldword="";
while(<>) {
	%defn=();
	s/^\#.*$//g;
	s/\s\#.*$//g;
	$canontag="";
	$ctag="";
	chop;
	@parts=split;
	$word=shift(@parts);
	$canon=join(" ",@parts);
	$canon=" $canon ";
	next if ($canon =~ /^\s*$/);
$lexicon="CMU" if !defined($lexicon);

##definitions
# VOWEL=AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR
# SVOWEL=AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW
# UVOWEL=AX|IX|AXR
# UNORVOWEL=AX|IX
# NASAL=M|N|NG
# LIQUID=L|R
# SEMIVOWEL=W|Y
# SYLABIC=EL|EM|EN
# VOICED=AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR|EL|EM|EN|M|N|NG|L|R|W|Y|B|D|G|DH|JH|V|Z|DX|NX
# VOICEDNONG=AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR|EL|EM|EN|N|M|L|R|W|Y|B|D|G|DH|JH|V|Z|DX|NX

##stop closures

##stop + stop

# SS1:S: B ([DGPTK]) -> [BCL] [$1]
	$canon =~ s/ B ([DGPTK]) / [BCL] [$1] /g;

# SS2:S: D ([BGPTK]) -> [DCL] [$1]
	$canon =~ s/ D ([BGPTK]) / [DCL] [$1] /g;

# SS3:S: G ([BDPTK]) -> [GCL] [$1]
	$canon =~ s/ G ([BDPTK]) / [GCL] [$1] /g;

# SS4:S: P ([BDGTK]) -> [PCL] [$1]
	$canon =~ s/ P ([BDGTK]) / [PCL] [$1] /g;

# SS5:S: T ([BDGPK]) -> [TCL] [$1]
	$canon =~ s/ T ([BDGPK]) / [TCL] [$1] /g;

# SS6:S: K ([BDGPT]) -> [KCL] [$1]
	$canon =~ s/ K ([BDGPT]) / [KCL] [$1] /g;

##stop + cons

# SC1:S: B ([SNMF]) -> [BCL] $1
	$canon =~ s/ B ([SNMF]) / [BCL] $1 /g;

# SC2:S: D ([SNMF]) -> [DCL] $1
	$canon =~ s/ D ([SNMF]) / [DCL] $1 /g;

# SC3:S: G ([SNMF]) -> [GCL] $1
	$canon =~ s/ G ([SNMF]) / [GCL] $1 /g;

# SC4:S: P ([NMF]) -> [PCL] $1
	$canon =~ s/ P ([NMF]) / [PCL] $1 /g;

# SC5:S: T ([SNLMF]) -> [TCL] $1
	$canon =~ s/ T ([SNLMF]) / [TCL] $1 /g;

# SC6:S: K ([NMF]) -> [KCL] $1
	$canon =~ s/ K ([NMF]) / [KCL] $1 /g;

## stop + end

# SE1:S: B *$-> [BCL] 
	$canon =~ s/ B *$/ [BCL] /g;

# SE2:S: D *$-> [DCL] 
	$canon =~ s/ D *$/ [DCL] /g;

# SE3:S: G *$-> [GCL] 
	$canon =~ s/ G *$/ [GCL] /g;

# SE4:S: P *$-> [PCL] 
	$canon =~ s/ P *$/ [PCL] /g;

# SE5:S: T *$-> [TCL] 
	$canon =~ s/ T *$/ [TCL] /g;

# SE6:S: K *$-> [KCL] 
	$canon =~ s/ K *$/ [KCL] /g;

##stop-gen

# SG1:S: B -> [BCL] [B]
	$canon =~ s/ B / [BCL] [B] /g;

# SG2:S: D -> [DCL] [D]
	$canon =~ s/ D / [DCL] [D] /g;

# SG3:S: G -> [GCL] [G]
	$canon =~ s/ G / [GCL] [G] /g;

# SG4:S: P -> [PCL] [P]
	$canon =~ s/ P / [PCL] [P] /g;

# SG5:S: K -> [KCL] [K]
	$canon =~ s/ K / [KCL] [K] /g;

# SG6:S: T -> [TCL] [T]
	$canon =~ s/ T / [TCL] [T] /g;

## get rid of brackets

# BR1:SD: \[ -> 
	$canon =~ s/\[//g;

# BR2:SD: \] ->
	$canon =~ s/\]//g;

## reduced vowels

# RV1:S: (AA|AE|AH|AO|EH|ER|EY|OW|UH)0 -> AX
	$canon =~ s/ (AA|AE|AH|AO|EH|ER|EY|OW|UH)0 / AX /g;

# RV2:S: (IY|IH|UW)0 -> IX
	$canon =~ s/ (IY|IH|UW)0 / IX /g;

# RV3:S: ER0 -> AXR
	$canon =~ s/ ER0 / AXR /g;

# :D: [012] ->
	$canon =~ s/[012]//g;

##flaps

# FL1:S: (VOWEL) [TD]CL [TD] (UVOWEL) -> $1 DX $2
	$canon =~ s/ (AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR) [TD]CL [TD] (AX|IX|AXR) / $1 DX $2 /g;

# FL2:S: (VOWEL) R [TD]CL [TD] (UVOWEL) -> $1 R DX $2
	$canon =~ s/ (AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR) R [TD]CL [TD] (AX|IX|AXR) / $1 R DX $2 /g;

##voiced h

# VH1:S: (VOICED) HH (VOICED) -> $1 HV $2
	$canon =~ s/ (AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR|EL|EM|EN|M|N|NG|L|R|W|Y|B|D|G|DH|JH|V|Z|DX|NX) HH (AA|AE|AH|AO|AW|AY|EH|ER|EY|IH|IY|OW|OY|UH|UW|AX|IX|AXR|EL|EM|EN|M|N|NG|L|R|W|Y|B|D|G|DH|JH|V|Z|DX|NX) / $1 HV $2 /g;

	@pron=();
	if ($canontag ne "") {
	$ctag="(+$lexicon$canontag)"; }
	 else { 
	$ctag="+$lexicon"; }
	&enter($canon,$ctag);

	for($counter=0;$counter<=$#pron;$counter++) {
		($tmp,$tag)=&getword($counter);
		$tmp =~ s/^ *//;
		$tmp =~ s/  */ /g;
		$tmp =~ s/ *$//;

		$tmp =~ tr/A-Z/a-z/;
		$word =~ tr/A-Z/a-z/;
		print $word,":",$tmp,":",$tag,"\n";
	}
}
